function util_get_time(){
    return new Date().getTime() ; // 1622427445085
}
function util_check_expire(expire_date=''){
    if(expire_date==''){
        return true;
    }
    expire_date = expire_date.replace('T00:00:00.000Z','');
    let now_date = new Date();
    expire_date_list = expire_date.split('-');
    expire_date_f = new Date(expire_date_list[0], (expire_date_list[1]-1), expire_date_list[2]);
    if (now_date > expire_date_f) {
        return true;
    }
    return false;
}

function util_url_get_domain(url=''){
    url = url.replace('https://','');
    url = url.replace('http://','');
    url = url.replace('www.','');
    let urlArr = url.split('/');
    if(urlArr.length>0){
        return urlArr[0];
    }
    return '';
}

function util_url_get_website(arg_url=''){
    // 要匹配的URL
    var url = arg_url;
    // 正则表达式模式，用于匹配协议和主机名
    var pattern = /^(https?):\/\/([^\/]+)(.*)$/;
    // 使用正则表达式进行匹配
    var matches = url.match(pattern);
    if (matches) {
      var protocol = matches[1]; // 协议部分，例如 "http" 或 "https"
      var hostname = matches[2]; // 主机名部分，例如 "www.example.com"

      return protocol+'://'+hostname;
    } else {
      return arg_url;
    }
}

function extract_google_search_export(){
    //
    var shangjia_infos = [];

    var q_name = $("textarea[name='q']").val();
    if(!q_name){
        q_name = $("input[name='q']").val();
    }

    var expire_data = get_expire();
    var expire_date_dict = expire_data[0];
    var expire_date = expire_date_dict['expire'];
    //if(util_check_expire(expire_date)==false) {
        //
        shangjia_infos.push({
            'url': '',
            'website':'',
            'domain': window.location.href,
            'title': '',
            'description':''
        })
        //
        let current_url = window.location.href;
        let is_google_yuansheng = true;
        let is_google_images = false;
        let is_google_videos = false;
        let is_google_shopping = false;
        //
        if(current_url){
            if(current_url.indexOf('tbm=isch') != -1){
                is_google_images = true;
                is_google_yuansheng = false;
            }else if(current_url.indexOf('tbm=vid') != -1){
                is_google_videos = true;
                is_google_yuansheng = false;
            }else if(current_url.indexOf('tbm=shop') != -1){
                is_google_shopping = true;
                is_google_yuansheng = false;
            }
        }
        //
        if(is_google_yuansheng || is_google_videos){
            if(is_google_yuansheng){
                q_name = 'google-ru-web-'+util_get_time();
            }
            if(is_google_videos){
                q_name = 'google-ru-videos-'+util_get_time();
            }
            $('#search .MjjYud').each(function (){
                let a_href_val = $(this).find('a').attr('href');
                let a_domain_val  = util_url_get_domain(a_href_val);
                let title = $(this).find('.yuRUbf h3.LC20lb').text();
                let description = $(this).find('.UK95Uc .lyLwlc').text();

                //
                let is_exists = false;
                for(j=0;j<shangjia_infos.length;j++){
                    if(shangjia_infos[j]['domain'] == a_domain_val){
                        is_exists = true;
                        break;
                    }
                }
                //
                if(is_exists == false){
                     shangjia_infos.push({
                         'url': a_href_val,
                         'website':util_url_get_website(a_href_val),
                         'domain': a_domain_val,
                         'title': title,
                         'description':description
                    })
                }
                //
            });
        }else if(is_google_images){
            q_name = 'google-ru-images-'+util_get_time();
            $('#islrg div.isv-r.PNCib').each(function (){
                let a_href_val = $(this).find('a.iGVLpd').attr('href');
                //console.log('a_href_val');
                //console.log(a_href_val);
                let a_domain_val  = util_url_get_domain(a_href_val);
                let title = $(this).find('h3').text();
                let description = $(this).find('a.VFACy .dmeZbb').text()+ ' '+ $(this).find('a.VFACy .OztcRd').text();
                //
                let is_exists = false;
                for(j=0;j<shangjia_infos.length;j++){
                    if(shangjia_infos[j]['domain'] == a_domain_val){
                        is_exists = true;
                        break;
                    }
                }
                //
                if(is_exists == false){
                    shangjia_infos.push({
                        'url': a_href_val,
                        'website':util_url_get_website(a_href_val),
                        'domain': a_domain_val,
                        'title': title,
                        'description':description
                    });
                }
                //
            });
        }else if(is_google_shopping){
            console.log('is_google_shopping test');
            q_name = 'google-ur-shopping-'+util_get_time();

            $('.sh-dgr__grid-result').each(function (){
                let a_href_val = $(this).find('span.shntl a.shntl').attr('href');
                a_href_val = a_href_val.replace('/url?url=', '');
                let a_domain_val  = util_url_get_domain(a_href_val);
                let title = $(this).find('h3').text();
                //
                let is_exists = false;
                for(j=0;j<shangjia_infos.length;j++){
                    if(shangjia_infos[j]['domain'] == a_domain_val){
                        is_exists = true;
                        break;
                    }
                }
                //
                if(is_exists == false){
                    shangjia_infos.push({
                        'url': a_href_val,
                        'website':util_url_get_website(a_href_val),
                        'domain': a_domain_val,
                        'title': title,
                        'description':''
                    });
                }
                //
            });
            //
            /*
            var shangjia_infos_localStorage = [];
            if(localStorage.getItem("shangjia_infos_localStorage") == null){
                localStorage['shangjia_infos_localStorage'] = JSON.stringify([]);
            }
            shangjia_infos_localStorage = JSON.parse(localStorage['shangjia_infos_localStorage']);
            shangjia_infos = shangjia_infos_localStorage;
            //*/
        }

    //}
     var catalog_products = {
         'shangjia_infos': shangjia_infos,
         'file_name': q_name,
         'expire':get_expire()
     }

     return catalog_products;
}

function util_extract_url(s) {
    //var reg = /(http:\/\/|https:\/\/)((\w|=|\?|\.|\/|&|-)+)/g;
    var reg= /(https?|http|ftp|file):\/\/[-A-Za-z0-9+&@#/%?=~_|!:,.;]+[-A-Za-z0-9+&@#/%=~_|]/g;
    s = s.match(reg);
    console.log(s);
    return(s)
}

function extract_sns_export(){
    //
    var shangjia_infos = [];

    var q_name = $("textarea[name='q']").val();
    var expire_data = get_expire();
    var expire_date_dict = expire_data[0];
    var expire_date = expire_date_dict['expire'];
    //if(util_check_expire(expire_date)==false) {
        //
        shangjia_infos.push({
            'url': q_name,
            'website':'',
            'domain': window.location.href,
            'title': '',
            'description': '',
            'source':''
        })
        //
        $('#search .MjjYud').each(function (){
            let _desc = $(this).find('.VwiC3b').text();
            let _extract_urls = util_extract_url(_desc);
            let _website = '';
            let _domain = '';
            let _title = $(this).find('.yuRUbf h3.DKV0Md').text();
            let _source = $(this).find('.yuRUbf a').attr('href');
            if(_extract_urls!=null){
                for(let j=0;j<_extract_urls.length;j++){
                     _website = _extract_urls[j];
                     _domain  = util_url_get_domain(_website);
                     _website = _website.trim();
                      break;
                }
            }
            if(_domain){
                //
                let is_exists = false;
                for(j=0;j<shangjia_infos.length;j++){
                    if(shangjia_infos[j]['domain'] == _domain){
                        is_exists = true;
                        break;
                    }
                }
                //
                if(!is_exists){
                     shangjia_infos.push({
                                        'url': _website,
                                        'website': util_url_get_website(_website),
                                        'domain': _domain,
                                        'title': _title,
                                        'description': _desc,
                                        'source':_source
                                    })
                }
            }

        });
    //}
     var catalog_products = {
         'shangjia_infos': shangjia_infos,
         'file_name': 'sns-'+util_get_time(),
         'expire':get_expire()
     }

     return catalog_products;
}

function set_expire(date=''){
    console.log('set_expire:'+date);
    var expire = [];
    if(localStorage.getItem("expire") == null){
        localStorage['expire'] = JSON.stringify([{'expire':''}]);
    }
    localStorage['expire'] = JSON.stringify([{'expire':date}]);

    expire = JSON.parse(localStorage['expire']);
    return expire;
}

function get_expire(){
    if(localStorage.getItem("expire") == null){
        localStorage['expire'] = JSON.stringify([{'expire':''}]);
    }
    expire = JSON.parse(localStorage['expire']);
    return expire;
}

/*yandex*/
function yandex_web_search_localStorage_clean(){
    console.log('yandex_web_search_localStorage_clean');
     //if(localStorage.getItem("tbm_map_urls") == null){
         localStorage['shangjia_infos_localStorage'] = JSON.stringify([]);
    // }
    localStorage.removeItem("shangjia_infos_localStorage");
}

function yandex_web_search_get_num(){
    var shangjia_infos_localStorage = [];
    if(localStorage.getItem("shangjia_infos_localStorage") == null){
        localStorage['shangjia_infos_localStorage'] = JSON.stringify([]);
    }
    shangjia_infos_localStorage = JSON.parse(localStorage['shangjia_infos_localStorage']);
    return shangjia_infos_localStorage.length;
}

//yandex web search
function yandex_web_search_update_localStorage(){
    let current_url = window.location.href;
    if(current_url.indexOf('images/search') == -1 && current_url.indexOf('video/search') == -1){
        console.log('b');
        var shangjia_infos_localStorage = [];
        if(localStorage.getItem("shangjia_infos_localStorage") == null){
            localStorage['shangjia_infos_localStorage'] = JSON.stringify([]);
        }
        shangjia_infos_localStorage = JSON.parse(localStorage['shangjia_infos_localStorage']);
        //
        $('.serp-list .serp-item,#search-result li').each(function (){
            console.log('a');
            //
            let shangjia_info_href = $(this).find('.OrganicTitle a').attr('href');
            let shangjia_info_title = $(this).find('.OrganicTitle h2').text();
            let shangjia_info_desc = $(this).find('.Organic-ContentWrapper .OrganicTextContentSpan').text();
            let shangjia_info_domain = util_url_get_domain(shangjia_info_href);
            //
            let is_exists = false;
            for(j=0;j<shangjia_infos_localStorage.length;j++){
                 if(shangjia_infos_localStorage[j]['domain'] == shangjia_info_domain){
                     is_exists = true;
                     break;
                 }
            }
            //
            if(is_exists == false){
                 shangjia_infos_localStorage.push({
                     'url':shangjia_info_href,
                     'website':util_url_get_website(shangjia_info_href),
                     'domain':shangjia_info_domain,
                     'title': shangjia_info_title,
                     'description': shangjia_info_desc
                 });
            }
            //
        });
        //
        localStorage['shangjia_infos_localStorage'] = JSON.stringify(shangjia_infos_localStorage);
        //
        var message = {
                action: 'shangjia_num_update',
                info: '',
                num:shangjia_infos_localStorage.length
        };
        console.log(message);
        send_message_to_popup(message);
    }
}
//yandex image search
function yandex_images_search_update_localStorage(){
    let current_url = window.location.href;
    if(current_url.indexOf('images/search') != -1){
        console.log('yandex_images_search_update_localStorage');
        var shangjia_infos_localStorage = [];
        if(localStorage.getItem("shangjia_infos_localStorage") == null){
            localStorage['shangjia_infos_localStorage'] = JSON.stringify([]);
        }
        shangjia_infos_localStorage = JSON.parse(localStorage['shangjia_infos_localStorage']);
        //
        $('.SerpList .SerpItem').each(function (){
            console.log('a');
            //
            let shangjia_info_href = '';
            let _href_tmp = $(this).find('a').attr('href');
            let _href_tmp_decode = decodeURIComponent(_href_tmp);
            let _href_tmp_arr = _href_tmp_decode.split('&img_url=');
            if(_href_tmp_arr.length >=2){
                let _href_tmp_2 = _href_tmp_arr[1];
                let _href_tmp_2_arr = _href_tmp_2.split('&');
                shangjia_info_href = _href_tmp_2_arr[0];
            }

            if(shangjia_info_href){
                let shangjia_info_domain = util_url_get_domain(shangjia_info_href);
                let shangjia_info_title = $(this).find('img').attr('alt');
                let shangjia_info_desc = '';
                console.log('_href_tmp_decode:'+_href_tmp_decode);
                console.log('shangjia_info_href');
                console.log(shangjia_info_href);
                //
                let is_exists = false;
                for(j=0;j<shangjia_infos_localStorage.length;j++){
                     if(shangjia_infos_localStorage[j]['domain'] == shangjia_info_domain){
                         is_exists = true;
                         break;
                     }
                }
                //
                if(is_exists == false){
                     shangjia_infos_localStorage.push({
                         'url':shangjia_info_href,
                         'website':util_url_get_website(shangjia_info_href),
                         'domain':shangjia_info_domain,
                         'title': shangjia_info_title,
                         'description': shangjia_info_desc
                     });
                }
                //
            }
        });
        //serp-item serp-item_type_search serp-item_group_search serp-item_pos_0 justifier__item i-bem serp-item_js_inited
         $('.justifier__cols .serp-item').each(function (){
            console.log('a');
            let _data_bem = $(this).attr('data-bem');
            let _data_bem_json = JSON.parse(_data_bem);
            console.log('_data_bem_json');
            console.log(_data_bem_json);
            if(_data_bem_json){
                //
                let shangjia_info_href = _data_bem_json['serp-item']['snippet']['url'];

                if(shangjia_info_href){
                    let shangjia_info_domain = _data_bem_json['serp-item']['snippet']['domain'];
                    let shangjia_info_title = _data_bem_json['serp-item']['snippet']['title'];
                    let shangjia_info_desc = _data_bem_json['serp-item']['snippet']['text'];
                    //
                    let is_exists = false;
                    for(j=0;j<shangjia_infos_localStorage.length;j++){
                         if(shangjia_infos_localStorage[j]['domain'] == shangjia_info_domain){
                             is_exists = true;
                             break;
                         }
                    }
                    //
                    if(is_exists == false){
                         shangjia_infos_localStorage.push({
                             'url':shangjia_info_href,
                             'website':util_url_get_website(shangjia_info_href),
                             'domain':shangjia_info_domain,
                             'title': shangjia_info_title,
                             'description': shangjia_info_desc
                         });
                    }
                    //
                }
            }
        });
        //
        localStorage['shangjia_infos_localStorage'] = JSON.stringify(shangjia_infos_localStorage);
        //
        var message = {
                action: 'shangjia_num_update',
                info: '',
                num:shangjia_infos_localStorage.length
        };
        console.log(message);
        send_message_to_popup(message);
        //
    }
}

var navigation_url = '';
function perf_observer(list, obserer){
    //console.log('aa');
    //console.log(getNetworkRequests(list.getEntriesByType('resource')));
    performanceResourceList = list.getEntriesByType('resource');
    //console.log(performanceResourceList);
    for(i = 0; i<performanceResourceList.length; i++){
        performanceResourceItem = performanceResourceList[i];
        //console.log('abababa');
        //console.log(performanceResourceItem);
        if(performanceResourceItem['initiatorType'] == 'xmlhttprequest'){
            //console.log('po:'+performanceResourceItem['name']);
            if(performanceResourceItem['name'].indexOf('images/search')!=-1 && performanceResourceItem['name'].indexOf('clck') == -1){
                console.log('bbbb'+performanceResourceItem['name']);
                //
                yandex_images_search_update_localStorage();
            }
        }
    }
    //////
    /*performanceNavigationList = list.getEntriesByType('navigation');
    for(i = 0; i<performanceNavigationList.length; i++) {
        performanceNavigationItem = performanceNavigationList[i];
        if (performanceNavigationItem['initiatorType'] == 'navigation') {
            navigation_url = performanceNavigationItem['name']
        }
    }*/
}
var observer_ = new PerformanceObserver(perf_observer);
//observer_.observe({entryTypes:['resource', 'navigation']});
observer_.observe({entryTypes:['resource', 'navigation', 'paint']});
//

$(document).ready(function(){
  console.log('document on load');
  //
    yandex_web_search_update_localStorage();
    //
});

function extract_yandex_search_export(){
    //
    var shangjia_infos = [];

    var q_name = $(".search2 input.input__control").val();
    if(!q_name){
        q_name = $("input[name='q']").val();
    }

    var expire_data = get_expire();
    var expire_date_dict = expire_data[0];
    var expire_date = expire_date_dict['expire'];
    //if(util_check_expire(expire_date)==false) {
        //
        shangjia_infos.push({
            'url': '',
            'website': '',
            'domain': window.location.href,
            'title': '',
            'description':''
        })
        //
        let current_url = window.location.href;
        let is_web_search = true;
        let is_image_search = false;
        //
        if(current_url){
            if(current_url.indexOf('images/search') != -1){
                is_web_search = false;
                is_image_search = true;
            }
        }
        //
        if(is_web_search || is_image_search){
            q_name = 'yandex-web-search-'+util_get_time();
            if(is_image_search){
                q_name = 'yandex-images-search-'+util_get_time();
            }
            //
            var shangjia_infos_localStorage = [];
            if(localStorage.getItem("shangjia_infos_localStorage") == null){
                localStorage['shangjia_infos_localStorage'] = JSON.stringify([]);
            }
            shangjia_infos_localStorage = JSON.parse(localStorage['shangjia_infos_localStorage']);
            for(let f=0;f<shangjia_infos_localStorage.length;f++){
                shangjia_infos.push(shangjia_infos_localStorage[f]);
            }
            //
            yandex_web_search_localStorage_clean();
            //
        }

    //}
     var catalog_products = {
         'shangjia_infos': shangjia_infos,
         'file_name': q_name,
         'expire':get_expire()
     }

     return catalog_products;
}


/*yandex end*/

// get popup2content info
chrome.runtime.onMessage.addListener((request, sender, sendResponse) => {
    if(request.action == 'extract_google_search_export'){
        catalog_products_url = extract_google_search_export();
        sendResponse(catalog_products_url);
    }else if(request.action == 'extract_sns_export') {
        catalog_products_url = extract_sns_export();
        sendResponse(catalog_products_url);
    }else if(request.action == 'yandex_web_search_get_num') {
        let shangjia_num = yandex_web_search_get_num();
        sendResponse(shangjia_num);
    }else if(request.action == 'extract_yandex_search_export'){
        catalog_products_url = extract_yandex_search_export();
        sendResponse(catalog_products_url);
    }else if(request.action == 'set_expire') {
        expire_date = set_expire(request.date);
        sendResponse(expire_date);
    }else if(request.action == 'get_expire'){
        expire_date = get_expire();
        sendResponse(expire_date);
    }
})
//

//send message to pop
function send_message_to_popup(message={}){
    /*
    {
            action: 'extract-catalog-products-export-clean',
            info: ''
        }
     */
    console.log('message');
    console.log(message);
    chrome.runtime.sendMessage(message,(msg)=>{
        console.log('答复',msg)
    })
}